import matplotlib.pyplot as plt
import numpy as np
import seaborn as sns
import pandas as pd

mpg = sns.load_dataset("mpg")

fn_filter = lambda x: True if x in [4, 6] else False
fn_mod = lambda x: {4: 'four', 6: 'six', 8: 'eight'}[x]
mpg_country = mpg[mpg["origin"] != "europe"]
mpg_demo = mpg_country[mpg_country['cylinders'].map(fn_filter)].copy()
mpg_demo['cylinders'] = mpg_demo['cylinders'].map(fn_mod)

plt.figure(figsize=(15, 5))
s_list = [0.25, 0.5, 0.75, 1]
for i, s in enumerate(s_list):
    plt.subplot(1, len(s_list), i + 1)
    sns.violinplot(x="origin", y="mpg", hue="cylinders", saturation=s, data=mpg_demo)

plt.show()
